"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.accessFasta = void 0;
const generic_filehandle_1 = require("generic-filehandle");
const indexedfasta_1 = require("@gmod/indexedfasta");
function accessFasta(refseq, start, end, fastaURL) {
    return __awaiter(this, void 0, void 0, function* () {
        const fastaFilehandle = new generic_filehandle_1.RemoteFile(fastaURL);
        const faiFilehandle = new generic_filehandle_1.RemoteFile(fastaURL + ".fai");
        const gziFilehandle = new generic_filehandle_1.RemoteFile(fastaURL + ".gzi");
        const t = new indexedfasta_1.BgzipIndexedFasta({
            fasta: fastaFilehandle,
            fai: faiFilehandle,
            gzi: gziFilehandle,
            chunkSizeLimit: 500000,
        });
        const upstreamstart = start - 499;
        const downstreamend = end + 499;
        const seq = yield t.getSequence(refseq, start, end);
        const upstream = yield t.getSequence(refseq, upstreamstart, start);
        const downstream = yield t.getSequence(refseq, end, downstreamend);
        return {
            seq: seq || "",
            upstream: upstream || "",
            downstream: downstream || "",
        };
    });
}
exports.accessFasta = accessFasta;
