"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
// eslint-disable-next-line @typescript-eslint/no-unused-vars
const react_1 = require("react");
const GenericSeqPanel_1 = __importDefault(require("./GenericSeqPanel"));
const fetchTranscripts_1 = __importDefault(require("../fetchTranscripts"));
function GenericGeneSeqPanel(props) {
    const { nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate } = props;
    const [result, setResult] = (0, react_1.useState)();
    const [error, setError] = (0, react_1.useState)();
    const [transcript, setTranscript] = (0, react_1.useState)();
    const [mode, setMode] = (0, react_1.useState)("gene");
    const feature = transcript || (result === null || result === void 0 ? void 0 : result[0]);
    (0, react_1.useEffect)(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            try {
                const res = yield (0, fetchTranscripts_1.default)({
                    nclistbaseurl,
                    fastaurl,
                    refseq,
                    start,
                    end,
                    gene,
                    urltemplate,
                });
                setResult(res);
            }
            catch (e) {
                console.error(e);
                setError(e);
            }
        }))();
    }, [nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate]);
    if (error) {
        return (0, jsx_runtime_1.jsx)("div", Object.assign({ style: { color: "red" } }, { children: `${error}` }));
    }
    else if (!result) {
        return (0, jsx_runtime_1.jsx)("div", { children: "Loading..." });
    }
    else {
        return ((0, jsx_runtime_1.jsxs)("div", Object.assign({ className: "GenericGeneSeqPanel" }, { children: ["Transcript:", (0, jsx_runtime_1.jsx)("select", Object.assign({ onChange: e => setTranscript(result.find(r => r.id() === e.target.value)) }, { children: result.map(r => ((0, jsx_runtime_1.jsx)("option", Object.assign({ value: r.id() }, { children: r.get("name") }), r.id()))) })), "Mode:", (0, jsx_runtime_1.jsxs)("select", Object.assign({ onChange: e => setMode(e.target.value) }, { children: [(0, jsx_runtime_1.jsx)("option", Object.assign({ value: "gene" }, { children: "gene" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "cds" }, { children: "CDS" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "cdna" }, { children: "cDNA" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "protein" }, { children: "protein" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "genomic" }, { children: "genomic" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "genomic_sequence_updown" }, { children: "genomic +500bp up and down stream" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "gene_collapsed_intron" }, { children: "gene with collapsed introns" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "gene_updownstream" }, { children: "gene with 500bp up and down stream" })), (0, jsx_runtime_1.jsx)("option", Object.assign({ value: "gene_updownstream_collapsed_intron" }, { children: "gene with 500bp up and down stream and collapsed introns" }))] })), (0, jsx_runtime_1.jsx)("br", {}), feature ? ((0, jsx_runtime_1.jsx)(GenericSeqPanel_1.default, Object.assign({}, props, { transcript: feature, mode: mode }))) : null] })));
    }
}
exports.default = GenericGeneSeqPanel;
