import { Feature, SimpleFeatureSerialized } from "@jbrowse/core/util/simpleFeature";
/**
 * wrapper to adapt nclist features to act like jbrowse 2 features
 */
export default class NCListFeature implements Feature {
    private ncFeature;
    private parentHandle?;
    private uniqueId;
    constructor(ncFeature: any, parent?: Feature, id?: string);
    set(): void;
    jb2TagToJb1Tag(tag: string): string;
    jb1TagToJb2Tag(tag: string): string;
    get(attrName: string): any;
    /**
     * Get an array listing which data keys are present in this feature.
     */
    tags(): string[];
    /**
     * Get the unique ID of this feature.
     */
    id(): string;
    /**
     * Get this feature's parent feature, or undefined if none.
     */
    parent(): Feature | undefined;
    /**
     * Get an array of child features, or undefined if none.
     */
    children(): Feature[] | undefined;
    toJSON(): SimpleFeatureSerialized;
}
