import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
// eslint-disable-next-line @typescript-eslint/no-unused-vars
import { useState, useEffect } from "react";
import GenericSeqPanel from "./GenericSeqPanel";
import transcriptList from "../fetchTranscripts";
export default function GenericGeneSeqPanel(props) {
    const { nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate } = props;
    const [result, setResult] = useState();
    const [error, setError] = useState();
    const [transcript, setTranscript] = useState();
    const [mode, setMode] = useState("gene");
    const feature = transcript || (result === null || result === void 0 ? void 0 : result[0]);
    useEffect(() => {
        (async () => {
            try {
                const res = await transcriptList({
                    nclistbaseurl,
                    fastaurl,
                    refseq,
                    start,
                    end,
                    gene,
                    urltemplate,
                });
                setResult(res);
            }
            catch (e) {
                console.error(e);
                setError(e);
            }
        })();
    }, [nclistbaseurl, fastaurl, refseq, start, end, gene, urltemplate]);
    if (error) {
        return _jsx("div", { style: { color: "red" }, children: `${error}` });
    }
    else if (!result) {
        return _jsx("div", { children: "Loading..." });
    }
    else {
        return (_jsxs("div", { className: "GenericGeneSeqPanel", children: ["Transcript:", _jsx("select", { onChange: e => setTranscript(result.find(r => r.id() === e.target.value)), children: result.map(r => (_jsx("option", { value: r.id(), children: r.get("name") }, r.id()))) }), "Mode:", _jsxs("select", { onChange: e => setMode(e.target.value), children: [_jsx("option", { value: "gene", children: "gene" }), _jsx("option", { value: "cds", children: "CDS" }), _jsx("option", { value: "cdna", children: "cDNA" }), _jsx("option", { value: "protein", children: "protein" }), _jsx("option", { value: "genomic", children: "genomic" }), _jsx("option", { value: "genomic_sequence_updown", children: "genomic +500bp up and down stream" }), _jsx("option", { value: "gene_collapsed_intron", children: "gene with collapsed introns" }), _jsx("option", { value: "gene_updownstream", children: "gene with 500bp up and down stream" }), _jsx("option", { value: "gene_updownstream_collapsed_intron", children: "gene with 500bp up and down stream and collapsed introns" })] }), _jsx("br", {}), feature ? (_jsx(GenericSeqPanel, { ...props, transcript: feature, mode: mode })) : null] }));
    }
}
